export default class GXTemplateKey {

    static STYLE_BOX_SHADOW = "box-shadow"

    /**
     * https://www.runoob.com/cssref/pr-font-font-size.html
     * font-size 属性用于设置字体大小。
     */
    static STYLE_FONT_SIZE = "font-size"

    /**
     * https://www.runoob.com/cssref/pr-font-font-family.html
     * font - family属性指定一个元素的字体。
     */
    static STYLE_FONT_FAMILY = "font-family"

    /**
     * https://www.runoob.com/cssref/pr-text-color.html
     *
     * Color属性指定文本的颜色。
     */
    static STYLE_FONT_COLOR = "color"

    /***
     * https://developer.mozilla.org/zh-CN/docs/Web/CSS/font-weight
     */
    static STYLE_FONT_WEIGHT = "font-weight"

    /**
     * https://developer.mozilla.org/zh-CN/docs/Web/CSS/background-color
     */
    static STYLE_BACKGROUND_COLOR = "background-color"


    static STYLE_HIDDEN = "hidden"

    /**
     * https://www.runoob.com/cssref/pr-background-image.html
     * background-image 属性设置一个元素的背景图像。
     */
    static STYLE_BACKGROUND_IMAGE = "background-image"

    /**
     * Gaiax 自定义属性
     * 行数
     */
    static STYLE_FONT_LINES = "lines"

    /**
     * https://www.runoob.com/cssref/css3-pr-text-overflow.html
     * text-overflow属性指定当文本溢出包含它的元素，应该发生什么。
     */
    static STYLE_FONT_TEXT_OVERFLOW = "text-overflow"

    /**
     * https://developer.mozilla.org/zh-CN/docs/Web/CSS/text-align
     * text-align属性指定元素文本的水平对齐方式。
     */
    static STYLE_FONT_TEXT_ALIGN = "text-align"

    /**
     * https://developers.weixin.qq.com/miniprogram/dev/component/image.html
     * 图片的裁剪方式
     */
    static STYLE_MODE = "mode"

    /**
     * 图片的裁剪方式类型
     */
    static STYLE_MODE_TYPE = "mode-type"

    /**
     * https://developer.mozilla.org/zh-CN/docs/Web/CSS/border-radius
     * border-radius 属性是一个最多可指定四个 border -*- radius 属性的复合属性
     */
    static STYLE_BORDER_RADIUS = "border-radius"

    static STYLE_BORDER_BOTTOM_LEFT_RADIUS = "border-bottom-left-radius"

    static STYLE_BORDER_BOTTOM_RIGHT_RADIUS = "border-bottom-right-radius"

    static STYLE_BORDER_TOP_LEFT_RADIUS = "border-top-left-radius"

    static STYLE_BORDER_TOP_RIGHT_RADIUS = "border-top-right-radius"

    /**
     * https://developer.mozilla.org/zh-CN/docs/Web/CSS/border-width
     * border-width属性设置一个元素的四个边框的宽度。。
     */
    static STYLE_BORDER_WIDTH = "border-width"

    /**
     * https://developer.mozilla.org/zh-CN/docs/Web/CSS/border-color
     * border-color属性设置一个元素的四个边框颜色
     */
    static STYLE_BORDER_COLOR = "border-color"

    /**
     * https://developer.mozilla.org/zh-CN/docs/Web/CSS/opacity
     * 设置一个div元素的透明度级别
     */
    static STYLE_OPACITY = "opacity"

    /**
     * https://developer.mozilla.org/zh-CN/docs/Web/CSS/line-height
     * CSS 属性用于设置多行元素的空间量，如多行文本的间距。
     */
    static STYLE_FONT_LINE_HEIGHT = "line-height"

    /**
     * https://developer.mozilla.org/zh-CN/docs/Web/CSS/text-decoration
     */
    static STYLE_FONT_TEXT_DECORATION = "text-decoration"

    /**
     * 文字自适应
     */
    static STYLE_FIT_CONTENT = "fit-content"

    /**
     * 弹性容器通过设置 display 属性的值为 flex 或 inline-flex将其定义为弹性容器。
     */
    static FLEXBOX_DISPLAY = "display"

    /**
     * 设置页面布局方式，如果我们设置 direction 属性为 rtl (right-to-left),弹性子元素的排列方式也会改变，页面布局也跟着改变:
     */
    static FLEXBOX_DIRECTION = "direction"

    /**
     * flex-direction 属性指定了弹性子元素在父容器中的位置。
     */
    static FLEXBOX_FLEX_DIRECTION = "flex-direction"

    /**
     * flex-wrap 属性用于指定弹性盒子的子元素换行方式。
     */
    static FLEXBOX_FLEX_WRAP = "flex-wrap"

    /**
     * overflow 属性规定当内容溢出元素框时发生的事情。
     */
    static FLEXBOX_OVERFLOW = "overflow"

    /**
     * align-items 设置或检索弹性盒子元素在侧轴（纵轴）方向上的对齐方式。
     */
    static FLEXBOX_ALIGN_ITEMS = "align-items"

    /**
     * align-self 属性用于设置弹性元素自身在侧轴（纵轴）方向上的对齐方式。
     */
    static FLEXBOX_ALIGN_SELF = "align-self"

    /**
     * align-content 属性用于修改 flex-wrap 属性的行为。类似于 align-items, 但它不是设置弹性子元素的对齐，而是设置各个行的对齐。
     */
    static FLEXBOX_ALIGN_CONTENT = "align-content"

    /**
     * 内容对齐（justify-content）属性应用在弹性容器上，把弹性项沿着弹性容器的主轴线（main axis）对齐。
     */
    static FLEXBOX_JUSTIFY_CONTENT = "justify-content"

    /**
     * 规定元素的定位类型。
     */
    static FLEXBOX_POSITION_TYPE = "position"

    static FLEXBOX_POSITION_LEFT = "left"

    static FLEXBOX_POSITION_RIGHT = "right"

    static FLEXBOX_POSITION_TOP = "top"

    static FLEXBOX_POSITION_BOTTOM = "bottom"

    /**
     * 外边距属性。
     */
    static FLEXBOX_MARGIN = "margin"

    static FLEXBOX_MARGIN_LEFT = "margin-left"

    static FLEXBOX_MARGIN_RIGHT = "margin-right"

    static FLEXBOX_MARGIN_TOP = "margin-top"

    static FLEXBOX_MARGIN_BOTTOM = "margin-bottom"

    /**
     * 内边距属性
     */
    static FLEXBOX_PADDING = "padding"

    static FLEXBOX_PADDING_LEFT = "padding-left"

    static FLEXBOX_PADDING_RIGHT = "padding-right"

    static FLEXBOX_PADDING_TOP = "padding-top"

    static FLEXBOX_PADDING_BOTTOM = "padding-bottom"

    /**
     * 边框属性
     */
    static FLEXBOX_BORDER = "border"

    static FLEXBOX_BORDER_LEFT = "border-left"

    static FLEXBOX_BORDER_RIGHT = "border-right"

    static FLEXBOX_BORDER_TOP = "border-top"

    static FLEXBOX_BORDER_BOTTOM = "border-bottom"

    /**
     * flex 属性用于指定弹性子元素如何分配空间。
     * [ flex-grow ]：定义弹性盒子元素的扩展比率。
     */
    static FLEXBOX_FLEX_GROW = "flex-grow"

    /**
     * flex 属性用于指定弹性子元素如何分配空间。
     * [ flex-shrink ]：定义弹性盒子元素的收缩比率。
     */
    static FLEXBOX_FLEX_SHRINK = "flex-shrink"

    /**
     * flex 属性用于指定弹性子元素如何分配空间。
     * [ flex-basis ]：定义弹性盒子元素的默认基准值。
     */
    static FLEXBOX_FLEX_BASIS = "flex-basis"

    /**
     * 规定页面内容包含框的尺寸和方向。
     */
    static FLEXBOX_SIZE = "size"

    static FLEXBOX_MIN_SIZE = "min-size"

    static FLEXBOX_MAX_SIZE = "max-size"

    static FLEXBOX_SIZE_WIDTH = "width"

    static FLEXBOX_SIZE_HEIGHT = "height"

    static FLEXBOX_MIN_WIDTH = "min-width"

    static FLEXBOX_MIN_HEIGHT = "min-height"

    static FLEXBOX_MAX_WIDTH = "max-width"

    static FLEXBOX_MAX_HEIGHT = "max-height"

    /**
     * 纵横比
     */
    static FLEXBOX_ASPECT_RATIO = "aspect-ratio"

    ///////////////////////////////////////
    ///////////////////////////////////////
    ///////////////////////////////////////

    static GAIAX_DATA = "data"

    static GAIAX_EVENT = "event"

    static GAIAX_CONFIG = "config"

    static GAIAX_ANIMATION = "animation"

    static GAIAX_LAYER_EDGE_INSETS = "edge-insets"

    static GAIAX_LAYER_LINE_SPACING = "line-spacing"

    static GAIAX_LAYER_INTERITEM_SPACING = "interitem-spacing"

    static GAIAX_LAYER_ITEM_SPACING = "item-spacing"

    static GAIAX_LAYER_ROW_SPACING = "row-spacing"

    static GAIAX_LAYER_COLUMN = "column"

    static GAIAX_LAYER_SCROLL_ENABLE = "scroll-enable"

    static GAIAX_LAYER_GRAVITY = "gravity"

    static GAIAX_LAYER_ID = "id"

    static GAIAX_LAYERS = "layers"

    static GAIAX_LAYER_TYPE = "type"

    static GAIAX_LAYER_SUB_TYPE = "sub-type"

    static GAIAX_LAYER_CUSTOM_VIEW_CLASS = "view-class-android"

    static GAIAX_LAYER_CLASS = "class"

    static GAIAX_PX = "px"

    static GAIAX_PT = "pt"

    static GAIAX_PE = "%"

    static GAIAX_AUTO = "auto"

    static GAIAX_LAYER_DIRECTION = "direction"
    static GAIAX_HORIZONTAL = "horizontal"
    static GAIAX_VERTICAL = "vertical"

    static GAIAX_HIGHLIGHT_REGEX = "(.*?)"

    static GAIAX_HIGHLIGHT_COLOR = "highlight-color"
    static GAIAX_HIGHLIGHT_FONT_WEIGHT = "highlight-font-weight"
    static GAIAX_HIGHLIGHT_FONT_SIZE = "highlight-font-size"
    static GAIAX_HIGHLIGHT_FONT_FAMILY = "highlight-font-family"
    static GAIAX_HIGHLIGHT_TAG = "highlight-tag"

    static GAIAX_UE = "ue"
    static GAIAX_ACCESSIBILITY_DESC = "accessibilityDesc"
    static GAIAX_ACCESSIBILITY_ENABLE = "accessibilityEnable"
    static GAIAX_PLACEHOLDER = "placeholder"
    static GAIAX_EXTEND = "extend"

    static GAIAX_LAYER = "layer"
    static GAIAX_DATABINDING = "databinding"
    static GAIAX_CSS = "css"
    static GAIAX_JS = "js"

    static GAIAX_INDEX_DATABINDING = "index.databinding"
    static GAIAX_INDEX_CSS = "index.css"
    static GAIAX_INDEX_JSON = "index.json"
    static GAIAX_INDEX_JS = "index.js"
    static GAIAX_INDEX_MOCK = "index.mock"

    static GAIAX_TEMPLATE_ID = "templateId"
    static GAIAX_TEMPLATE_VERSION = "templateVersion"
    static GAIAX_TEMPLATE_BIZ = "templateBiz"
    static GAIAX_TEMPLATE_TYPE = "templateType"

    static GAIAX_GESTURE_TYPE = "type"
    static GAIAX_GESTURE_TYPE_TAP = "tap"
    static GAIAX_GESTURE_TYPE_JS_TAP = "click"
    static GAIAX_GESTURE_TYPE_LONGPRESS = "longpress"

    static GAIAX_CUSTOM_PROPERTY_VIEW_PORT_WIDTH = "view-port-width"
    static GAIAX_CUSTOM_PROPERTY_GRID_COMPUTE_CONTAINER_HEIGHT = "grid-compute-container-height"
    static GAIAX_CUSTOM_PROPERTY_SCROLL_COMPUTE_CONTAINER_HEIGHT =
        "scroll-compute-container-height"

    static GAIAX_ICONFONT_FONT_FAMILY_DEFAULT_NAME = "iconfont"

    static GAIAX_DATABINDING_HOLDING_OFFSET = "holding-offset"
    static GAIAX_DATABINDING_ITEM_TYPE = "item-type"
    static GAIAX_DATABINDING_ITEM_TYPE_PATH = "path"
    static GAIAX_DATABINDING_ITEM_TYPE_CONFIG = "config"

    static GAIAX_CONTAINER_FOOTER = "item-footer-type"
    static GAIAX_CONTAINER_HAS_MORE = "hasMore"

    static GAIAX_ANIMATION_TYPE_LOTTIE = "LOTTIE"
    static GAIAX_ANIMATION_TYPE_PROP = "PROP"


    // GXSliderView
    static GAIAX_LAYER_SLIDER_SCROLL_TIME_INTER = "slider-scroll-time-inter"
    static GAIAX_LAYER_SLIDER_INFINITY_SCROLL = "slider-infinity-scroll"
    static GAIAX_LAYER_SLIDER_HAS_INDICATOR = "slider-has-indicator"
    static GAIAX_LAYER_SLIDER_SELECTED_INDEX = "slider-selected-index"
    static GAIAX_LAYER_SLIDER_INDICATOR_SELECTED_COLOR = "slider-indicator-selected-color"
    static GAIAX_LAYER_SLIDER_INDICATOR_UNSELECTED_COLOR = "slider-indicator-unselected-color"

    // GXProgressView
    static GAIAX_LAYER_PROGRESS_STROKE_COLOR = "stroke-color"
    static GAIAX_LAYER_PROGRESS_TRAIL_COLOR = "trail-color"
    static GAIAX_LAYER_PROGRESS_TYPE = "progress-type"
    static GAIAX_LAYER_PROGRESS_ANIMATED = "animated"
}